/* pmatrix.cpp: by Jonah Cohen
 *
 * This is a matrix class designed to work without any
 * jury-rigging, crying, sweat, blood, or tears when substituted for
 * the apmatrix class published by the College Board for use in the
 * AP Computer Science curriculum.
 *
 * pmatrix.cpp is distributed under the GNU Public License agreement (GPL)
 * for distribution, use, sale, modification, and obfuscation at NO CHARGE.
 * However, any use of this code must be accompanied by a thorough and
 * conspicuous acknowledgement of the use of open source code, as well as of
 * the original author or authors.
 *
 * Last modified March 23, 2001
 */

#include "pmatrix.h"

template <class T>
pmatrix<T>::pmatrix()
{}

template <class T>
pmatrix<T>::pmatrix(int rows, int cols)
{
	resize(rows,cols);
}

template <class T>
pmatrix<T>::pmatrix(int rows, int cols, const T & fillvalue)
{
	resize(rows,cols);
	for(int x = 0; x < rows; x++)
		for(int y = 0; y < cols; y++)
			matrix[x][y] = fillvalue;
}

template <class T>
pmatrix<T>::pmatrix(const pmatrix<T> & copy)
{
	*this = copy;
}

template <class T>
pmatrix<T>::~pmatrix()
{}

template <class T>
int pmatrix<T>::numrows() const
{
	return matrix.length();
}

template <class T>
int pmatrix<T>::numcols() const
{
	return (matrix.length())?matrix[0].length():0;
}

template <class T>
void pmatrix<T>::resize(int rows, int cols)
{
	matrix.resize(rows);
	for(int x = 0; x < rows; x++)
		matrix[x].resize(cols);	//resize each individual vector
}

template <class T>
const pmatrix<T> & pmatrix<T>::operator = (const pmatrix<T> & copy)
{
	matrix = copy.matrix;		//copy vector of vectors
	return *this;
}

template <class T>
const pvector<T> & pmatrix<T>::operator [] (int index) const
{
	return matrix[index];
}

template <class T>
pvector<T> & pmatrix<T>::operator [] (int index)
{
	return matrix[index];
}

