/* pvector.h: by Jonah Cohen
 *  
 * This is a vector class designed to work without any
 * jury-rigging, crying, sweat, blood, or tears when substituted for
 * the apvector class published by the College Board for use in the
 * AP Computer Science curriculum.
 *
 * pvector.h is distributed under the GNU Public License agreement (GPL)
 * for distribution, use, sale, modification, and obfuscation at NO CHARGE.
 * However, any use of this code must be accompanied by a thorough and
 * conspicuous acknowledgement of the use of open source code, as well as of
 * the original author or authors.
 *
 * Last modified March 23, 2001
 */

#ifndef _PVECTOR_H_
#define _PVECTOR_H_

template <class T>
class pvector
{

public:
	pvector();									//default constructor
	pvector(int size);							//constructor with specific dimension
	pvector(int size, const T &fill_val);		//create a pvector with a default fill value
	pvector(const pvector<T> &);				//copy constructor
	virtual ~pvector();							//destructor

	void resize(int new_size);					//resize the vector

	inline int length() const;					//returns number of elements in pvector

	T & operator [] (int index);				//access a particular array element (mutable)
	const T & operator [] (int index) const;	//access a particular array element (immutable)

	const pvector<T> & operator = (const pvector<T> &);	//assignment operator

protected:
	T *array;
	int len;

};

#include"pvector.cpp"

#endif

